Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.sort
Class AtomicSortComparer

    java.lang.Object
      net.sf.saxon.sort.AtomicSortComparer

All Implemented Interfaces:
  Serializable, AtomicComparer

    public class AtomicSortComparer

extends Object
implements AtomicComparer

An AtomicComparer used for comparing atomic values of arbitrary item types. It encapsulates a collator that is used when the values to be compared are strings. It also supports a separate method for testing equality of items, which can be used for data types that are not ordered. The AtomicSortComparer is identical to the GenericAtomicComparer except for its handling of NaN: it treats NaN values as lower than any other value, and as equal to each other.

Author:
  Michael H. Kay
See Also:
  Serialized Form

Field Summary
`static StringValue` | `COLLATION_KEY_NaN`

Method Summary
`int` | `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` | `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`ComparisonKey` | `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
`int` | `getItemType()` Get the requested item type
`StringCollator` | `getStringCollator()` Get the underlying StringCollator
`static AtomicComparer` | `makeSortComparer(StringCollator collator, int itemType, XPathContext context)` Factory method to get an atomic comparer suitable for sorting or for grouping (operations in which NaN is considered equal to NaN)

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### COLLATION_KEY_NaN

    public static StringValue COLLATION_KEY_NaN

Method Detail

### makeSortComparer

    public static AtomicComparer makeSortComparer(StringCollator collator,
                                                  int itemType,
                                                  XPathContext context)

  Factory method to get an atomic comparer suitable for sorting or for grouping (operations in which NaN is considered equal to NaN)

  Parameters:
    `collator` - Collating comparer to be used when comparing strings. This argument may be null if the itemType excludes the possibility of comparing strings. If the method is called at compile time, this should be a NamedCollation so that it can be cloned at run-time.
    `itemType` - the primitive item type of the values to be compared
    `context` - Dynamic context (may be an EarlyEvaluationContext)
  Returns:
    a suitable AtomicComparer

### getStringCollator

    public StringCollator getStringCollator()

  Get the underlying StringCollator

### getItemType

    public int getItemType()

  Get the requested item type

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should normally be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a0 if a>b
  Throws:
    `ClassCastException` - if the objects are not comparable

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the equals() method.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    true if the values are equal, false if not
  Throws:
    `ClassCastException` - if the objects are not comparable

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal, then their comparison keys are equal, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.